
import tensorflow as tf
from tensorflow.python.framework import graph_util
import os

def ckpt2pb():
    with tf.Graph().as_default() as graph_old:
        isess = tf.InteractiveSession()

        ckpt_filename = './MobileUnetCkpt/latest_model_MobileUNet_dataset.ckpt'
        isess.run(tf.global_variables_initializer())
        saver = tf.train.import_meta_graph(ckpt_filename+'.meta', clear_devices=True)
        saver.restore(isess, ckpt_filename)

        constant_graph = graph_util.convert_variables_to_constants(isess, isess.graph_def, ["softmax_cross_entropy_with_logits_sg"])
        constant_graph = graph_util.remove_training_nodes(constant_graph)

        with tf.gfile.GFile('./model.pb', mode='wb') as f:
            f.write(constant_graph.SerializeToString())

def pb2tflite():

    graph_def_file = './model.pb'
    input_arrays = ['Placeholder']
    output_arrays = ['softmax_cross_entropy_with_logits_sg/Reshape']
    input_shapes = { "Placeholder": [1,224,224,3] }

    # Convert the model
    converter = tf.lite.TFLiteConverter.from_frozen_graph(graph_def_file,input_arrays,output_arrays,input_shapes) # path to the SavedModel directory
    tflite_model = converter.convert()

    # Save the model.
    with open('model.tflite', 'wb') as f:
        f.write(tflite_model)

ckpt2pb()
pb2tflite()
os.system('python -m tf2onnx.convert --tflite ./model.tflite --output model.onnx --inputs-as-nchw Placeholder --opset 11')



